<?php
/*
Plugin Name: ads-WpLoginMenu
Plugin URI: www.ad-soft.ch/wploginmenu
Author: ad-software
Author URI: http://ad-soft.ch
Description: Displays Sign in or out on a menu item of your choice. Just define simply the "#ads-loginout#" or "#ads-loginout#Sign in;Sign out" shortcode in a link Element in the URL field, and then paste the link element to the menu. MenuText will be replaced from theme or defined shortcode-text. No parameters to setup.
Not designed for multi-pages. You can try it without warranty.
Version: 1.0.5
License: GNU General Public License v2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
Tags: Wp Site Count, ad-software, Display Site Counter
Text Domain: ads_wploginmenu
Domain path: /lang
Date : 2014/09/23 /2017/05/29

Copyright 2014  ad-software andré
contact me at www.ad-soft.ch/support

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as 
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

defined('ABSPATH') OR exit;

//=================================
//Constants
//=================================
if (!defined('ADSWLM_LOGINOUT'))	define('ADSWLM_LOGINOUT','#ads-loginout#');

add_filter( 'wp_get_nav_menu_items', 'adswlm_items' );

//Shortcode into menu
function adswlm_items( $items , $menus = null, $args = null ){
	if (is_admin()) 
		return ($items);
	foreach ($items as $key => $item ) {
		$x1 = wp_specialchars_decode($item->url);
		$p1 = strpos(strtolower($x1), ADSWLM_LOGINOUT);
		if ($p1 !== false) {
			// found loginmenucode
			$l1 = strlen(ADSWLM_LOGINOUT);
			$login = __('Sign in');
			$logout = __('Sign out');
			//check titlestring with language
			$x2 = wp_specialchars_decode($item->title);
			$gl = get_locale()."    ";
			// search 2 chars language code
			$lang = strtolower('{'.substr($gl,0,2).'}');
			$l2 = strlen($lang);
			$p2 = strpos(strtolower($x2), $lang);
			if ($p2 === false) {
				// search for 5 chars language code
				$lang = strtolower('{'.substr($gl,0,5).'}');
				$l2 = strlen($lang);
				$p2 = strpos(strtolower($x2), $lang);
			}
			if ($p2 !== false) {
				// found on title, use it
				$z = explode(";", substr($x2, $p2+$l2).';', 3);
				$login = $z[0];
				$logout = $z[1];
			}  else { 
				// search on url
				$p2 = strpos($x1,';');
				$p2 = strpos($x1,';');
				if ($p2 !== false && $p2 > $l1){
					$login = substr($x1, $l1, $p2-$l1);
					$logout = substr($x1, $p2+1);
				}
			}
			if ( ! is_user_logged_in() ) {
				$item->title = $item->attr_title = $item->post_title = $login;
				$item->url = esc_url( wp_login_url('index.php') );
			} else {
				$item->title = $item->attr_title = $item->post_title = $logout;
				$item->url = esc_url( wp_logout_url('index.php') ) ;
			}
		}	
		if (adswlm_startsWith($x1, '[') ) { //url href
			$item->url = do_shortcode( $x1 );
		}
		$x1 = wp_specialchars_decode($item->title);
		if (adswlm_startsWith($x1, '[') ) { // normal titel used
			$item->title = do_shortcode( $x1 );
		}
		// artisteer4 like this as text, unknown why not title
		$x1 = wp_specialchars_decode($item->post_title);
		if (adswlm_startsWith($x1, '[') ) {
			$item->post_title = do_shortcode( $x1 );
		}
	}
  return $items;
}

//=================================
function adswlm_startsWith($haystack, $needle)
{
    return $needle === "" || strpos($haystack, $needle) === 0;
}
?>